      program reset_header

      INCLUDE         'GLS.CMN'

      CHARACTER*80           GLS_FILE_NAME
      COMMON /GLS_FILE_NAME/ GLS_FILE_NAME

      CHARACTER*90    FN, line, line2
      CHARACTER*8     JPI
      CHARACTER*6     KAY


      IR = 5
      IW = 6
      IP = 3

 100  call cask('File name = ? (.ags)',fn,nc)
      if (nc.eq.0) call exit(0)

      CALL SETEXT(fn,'.ags',JEXT)
      GLS_FILE_NAME = fn
      fn(jext:jext+3) = '.txt'

C            ....read level scheme from .gls file....
      CALL SETEXT(GLS_FILE_NAME,'.ags',JEXT)
      OPEN (25,FILE=GLS_FILE_NAME,STATUS='OLD',ERR=920)
      CALL READ_ASCII_GLS
      OPEN (2,FILE=fn,STATUS='OLD',ERR=930)

C   write out ascii version of gls file (.ags file).....
      CALL OPEN_PR_FILE(25,GLS_FILE_NAME)
      do i = 1, 3
         read(2,'(a)') line
         do j = 90, 1, -1
            if (line(j:j).ne.' ') go to 20
         enddo
 20      write (25,'(a)') line(1:j)
      enddo
      read(2,'(a)') line
      read(2,'(a)') line2
      do j = 90, 1, -1
         if (line(j:j).ne.' ') go to 21
      enddo
 21   write (25,'(a)') line(1:j)//'  on '//line2(25:43)
      write (25,'(a)') '** ** NOTE THAT SOME ENSDF ASSIGNMENTS '//
     +                 'ARE NOT PRESERVED - see .txt file **'
      write (25,'(a)') ' ASCII GLS file format version 1.0'
      WRITE (25,55) ATOMIC_NO, LEVEL, GAMMA, NBANDS, NTLABEL,
     +               CSX, CSY, ASPECT_RATIO, MAX_TANGENT, MAX_DIST,
     +               DEFAULT_WIDTH, DEFAULT_SEP, ARROW_WIDTH,
     +               ARROW_LENGTH, ARROW_BREAK, LEVEL_BREAK,
     +               L_CSX, L_CSY, L_E_CSX, L_E_CSY, G_CSX, G_CSY
      WRITE (25,60)
      DO J = 1, LEVEL
         J2 = NINT(2.0*LEVDATA(J,3))
         J1 = J2/2
         IF (J2.EQ.2*J1) THEN
            WRITE(JPI,'(I7)') J1
         ELSE
            WRITE(JPI,'(I5)') J2
            JPI(6:7) = '/2'
         ENDIF
         IF (LEVDATA(J,4).LT.0.0) THEN
            JPI(8:8) = '-'
         ELSE
            JPI(8:8) = '+'
         ENDIF
         J2 = NINT(2.0*LEVDATA(J,5))
         J1 = J2/2
         IF (J2.EQ.2*J1) THEN
            WRITE(KAY,'(I6)') J1
         ELSE
            WRITE(KAY,'(I4)') J2
            KAY(5:6) = '/2'
         ENDIF
         WRITE (25,65) J, (LEVDATA(J,K),K=1,2), JPI, KAY, BAND(J),
     +        LEVEL_FLAG(J), L_LABEL_FLAG(J), L_E_LABEL_FLAG(J),
     +        L_LABEL_DX(J), L_LABEL_DY(J),
     +        L_E_LABEL_DX(J), L_E_LABEL_DY(J),
     +        LEVEL_DX(1,J), LEVEL_DX(2,J)
      ENDDO
      WRITE (25,70)
      DO J = 1, NBANDS
         WRITE (25,75) J, BAND_NAME(J), BAND_X0(J), BAND_NX(J),
     +        B_LABEL_DX(J), B_LABEL_DY(J),
     +        B_E_LABEL_DX(J), B_E_LABEL_DY(J)
      ENDDO
      WRITE (25,80)
      DO J = 1, GAMMA
         WRITE (25,85) J, GAMDATA(J,1), GAMDATA(J,2), GAML(J),
     +        NINT(GAMN(J)), (GAMID(J,K),K=1,2), 
     +        GAMDATA(J,3), GAMDATA(J,4),
     +        GAMDATA(J,6), GAMDATA(J,8), GAMDATA(J,5), 
     +        GAMDATA(J,10), GAMDATA(J,7), GAMDATA(J,9), 
     +        GAMMA_X1(J), GAMMA_X2(J),
     +        G_LABEL_DX(J), G_LABEL_DY(J),
     +        GAMMA_FLAG(J), G_LABEL_FLAG(J)
      ENDDO
      WRITE (25,90)
      DO J = 1, NTLABEL
         WRITE (25,95) J, TLABEL(J), TLABEL_NC(J),
     +        TCSX(J), TCSY(J), TLABEL_X(J), TLABEL_Y(J)
      ENDDO
      go to 100

55    FORMAT(
     + '**  Z Nlevels Ngammas  Nbands Nlabels CharSizeX CharSizeY',
     + ' ArrowWidFact'/
     + I5,4I8,3F10.2/
     + '**  MaxArrowTan MaxArrowDX DefBandWid DefBandSep ArrowWidth',
     + ' ArrowLength'/
     + F15.6,5F11.2/
     + '** ArrowBreak LevelBreak   LevCSX   LevCSY LevEnCSX LevEnCSY',
     + '   GamCSX   GamCSY'/
     +  2F12.2, 6F9.2)
60    FORMAT('** Level   Energy +/- err     Jpi     K Band#',
     + ' LevelFlag LabelFlag EnLabFlag'/
     + '++   LabelDX   LabelDY EnLabelDX EnLabelDY  LevelDX1  LevelDX2')
65    FORMAT(I6,F11.3,F8.3,A8,A6,I6,3I10,' &'/'++',6F10.2)
70    FORMAT('** Band   Name        X0        NX',
     +       '   LabelDX   LabelDY EnLabelDX EnLabelDY')
75    FORMAT(I5,1X,A8,6F10.2)
80    FORMAT(
     + '** Gamma   Energy +/- err  Mult  ILev  FLev  Intensity +/- err'/
     + '++     ConvCoef +/- error      BrRatio +/- error',
     + '     MixRatio +/- error'/
     + '++   GammaX1  GammaX2  LabelDX  LabelDY GammaFlag LabelFlag')
85    FORMAT(I6,F11.3,F8.3,3X,A,I2,2I6,F11.4,F8.4,' &'/
     +       '++',3(E13.5,E10.3),' &'/
     +       '++',4F10.2,2I10)
90    FORMAT(
     + '** Label                                   text  NChars'/
     + '++     SizeX     SizeY PositionX PositionY')
95    FORMAT(I5,2X,A40,I8,' &'/'++',4F10.2)


C         error messages....
 920  WRITE(IW,*) 'File ',GLS_FILE_NAME,' does not exist.'
      go to 100
 930  WRITE(IW,*) 'File ',fn,' does not exist.'
      go to 100

      END
